ObjectStore Anypoint&trade; Studio Connector Demo (Batch Write)
===============================================================

## Introduction

The present demo uses the connector to **write data in batch mode**. Essentially, multiple calls to the flow accumulate the data in the ObjectStore and, 
once it reaches a **batch count**, the subsequent call **commits the result into a file**.

## Prerequisites

* Java 7
* Anypoint Studio 5.4.x
* Mule Runtime 3.7.0 EE or higher
* DataWeave

## Import the project

* Go to **File > Import**
* Select **Anypoint Studio Project from External Location** (under the parent folder "Anypoint Studio")

![Menu](images/obj_import_menu.png)

* Provide the root path to the demo project folder.
* Select Mule Runtime (3.7.x EE).

![File Selection](images/obj_import_file.png)

* Click **Finish**.  

* Once successfully imported, from the Package Explorer view, expand the demo project and open the `mule-app.properties` file to change the batch property, if required. 

## About the flows

**1. Html_Form_Flow:** initializes two object stores, Counter and User, and renders the HTML form.

![Flow HTML Form](images/obj_flow_htmlForm.png)

**2. Crud_Batch_Write_Flow:** performs the core operations of the demo. **First**, the flow does retrieves the current counter value from Object Store using retrieve operation. 
Then, it builds the data from the HTTP query params and checks if the counter is divisible by the batch value. 
By default the batch value is 2. This means: every 2 calls of the demo, the data will be committed to the file. The data is accumulated in the User Object Store.      

![Flow CRUD Batch Write](images/obj_flow_crud.png)

## Run the demo

* **Deploy** the demo application.

* **Open** a browser, hit the URL **http://localhost:8081/demo** to display the main page. 

    ![Flow HTML Form](images/obj_demo_home.png)

* **Fill in** the requested fields (First Name, Last Name and Age).

* **Click** the Save button and wait a few seconds to finish processing. A pop-up message will indicate if the operation was successful or not by displaying the current saved object store data.
    > To view the output of individual flows, you can directly specify the HTTP query params in the URL, like this: `http://localhost:8081/demo/crud?name=me&lname=mySurname&age=4`

* **Congratulations!** You have successfully run this demo. Continue exploring the possibilities of the connector by visiting the [Object Store Connector Documentation Site](https://docs.mulesoft.com/mule-user-guide/v/3.7/object-store-connector).